Imports GrapeCity.ActiveReports 
Imports GrapeCity.ActiveReports.Document
Imports GrapeCity.ActiveReports.Chart

Public Class rptPie 

    Private Sub detail_Format(sender As System.Object, e As System.EventArgs) Handles detail.Format
        Me.chartControl1.Legends(0).Alignment = GrapeCity.ActiveReports.Chart.Alignment.Bottom
        Dim s As New Series()
        Me.chartControl1.Series.Add(s)
        s.Type = ChartType.Doughnut3D
        s.ValueMemberX = "ProductName"
        ' Value to X axis
        s.ValueMembersY = "UnitsInStock"
        ' Value to Y axis
        s.Marker = New Marker(GrapeCity.ActiveReports.Chart.Graphics.AntiAliasMode.Graphics)
        s.ChartArea = Me.chartControl1.ChartAreas(0)

        Dim i As Integer = 0
        Dim colorCount As Integer = 0
        Dim seriesTotal As Double = 0.0

        For i = 0 To s.Points.Count - 1
            Dim bd As BackdropItem = Nothing
            Select Case colorCount
                Case 0
                    bd = New BackdropItem(System.Drawing.Color.Blue)
                    Exit Select
                Case 1
                    bd = New BackdropItem(System.Drawing.Color.Yellow)
                    Exit Select
                Case 2
                    bd = New BackdropItem(System.Drawing.Color.Violet)
                    Exit Select
                Case 3
                    bd = New BackdropItem(System.Drawing.Color.Red)
                    Exit Select
                Case 4
                    bd = New BackdropItem(System.Drawing.Color.Black)
                    Exit Select
                Case 5
                    bd = New BackdropItem(System.Drawing.Color.Pink)
                    Exit Select
                Case 6
                    bd = New BackdropItem(System.Drawing.Color.Purple)
                    Exit Select
                Case 7
                    bd = New BackdropItem(System.Drawing.Color.Gray)
                    Exit Select
                Case 8
                    bd = New BackdropItem(System.Drawing.Color.Green)
                    Exit Select
                Case 9
                    bd = New BackdropItem(System.Drawing.Color.White)
                    Exit Select
                Case 10
                    bd = New BackdropItem(System.Drawing.Color.Orange)
                    Exit Select
            End Select

            colorCount = colorCount + 1
            s.Points(i).Properties("Backdrop") = bd
            seriesTotal = seriesTotal + s.Points(i).YValues(0)
            s.Points(i).LegendText = s.Points(i).XValue.ToString()
        Next

        Dim markerFont As System.Drawing.Font = New Font("Arial", 7)

        For i = 0 To s.Points.Count - 1
            Dim m As New Marker(GrapeCity.ActiveReports.Chart.Graphics.AntiAliasMode.Graphics)
            m.Label = New LabelInfo(GrapeCity.ActiveReports.Chart.Graphics.AntiAliasMode.Auto)
            m.Label.Font = New GrapeCity.ActiveReports.Chart.FontInfo(System.Drawing.Color.Black, markerFont, 0)
            m.Label.Format = s.Points(i).XValue.ToString() + ", " + (s.Points(i).YValues(0) / seriesTotal).ToString("#,###.##%")
            s.Points(i).Marker = m
        Next
    End Sub

    Private Sub rptPie_ReportStart(sender As System.Object, e As System.EventArgs) Handles MyBase.ReportStart
        Dim ds As New GrapeCity.ActiveReports.Data.OleDBDataSource()
        ds.ConnectionString = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source=C:\Program Files\GrapeCity\ActiveReports 6\Data\NWIND.mdb;Persist Security Info=False"
        ds.SQL = "Select * from products where unitprice < 10"
        ds.CommandTimeout = 30
        Me.chartControl1.DataSource = ds
    End Sub
End Class
